UNIT DIALOG1;

INTERFACE
USES TERMUSER;

  PROCEDURE SendAutoDlg;
  PROCEDURE SendAutoDlg_Auswert;
  PROCEDURE ReceiveAutoDlg;
  PROCEDURE ReceiveAutoDlg_Auswert;
  PROCEDURE ReceiveTextDlg;
  PROCEDURE ReceiveTextDlg_Auswert;
  PROCEDURE ReceiveText;
  PROCEDURE SendTextDlg;
  PROCEDURE SendTextDlg_Auswert;
  PROCEDURE KanalSettingsDlg;
  PROCEDURE KanalSettingsDlg_Auswert;
  PROCEDURE MCUTEndeDlg;
  PROCEDURE MCUTEndeDlg_Auswert;
  PROCEDURE CallChangeDlg;
  PROCEDURE CallChangeDlg_Auswert;
  PROCEDURE UserSettingsDlg;
  PROCEDURE UserSettingsDlg_Auswert;
  PROCEDURE UserSettingsDlg2;
  PROCEDURE UserSettingsDlg2_Auswert;
  PROCEDURE UserSettingsRemotesDlg;
  PROCEDURE UserSettingsRemotesDlg_Auswert;
  PROCEDURE UserSettingsOtherDlg;
  PROCEDURE UserSettingsOtherDlg_Auswert;
  PROCEDURE ReceiveOverWriteDlg(s:string);
  PROCEDURE ReceiveOverWriteDlg_AusWert;

VAR
  dlg_u:TTermUserRec;

IMPLEMENTATION
USES IADVAR,MCUTLIB2,SCREEN,CRT,
     {$IFDEF WA8DED}
     TNC,
     {$ENDIF}
     {$IFDEF FLEXNET}
     FLXAPP,
     {$ENDIF}
     TOOLBOX,MYSTRING,
     INPUT,DOS,MCUTLIB,PACKET,TERMSCAN,TERM_O,DMCUT;

VAR L,R:STRING[10];
       dlgbool, dlgbool1,dlgbool2,dlgbool3,dlgbool4:boolean;
       dlgflags:ARRAY[1..10] OF BYTE;
       along:longint;err:integer;

PROCEDURE SendAutoDlg;
BEGIN
  IF KS[channel]^.Status=16 THEN
  BEGIN
    Close(KS[channel]^.SendFile);
    KS[channel]^.SendMode:=0;
    PutData(channel,'#ABORT#'+#13+#13);
    PutData(channel,'AUTOBIN-Transfer aborted by sender'+#13);
    KS[channel]^.status:=KS[channel]^.Laststatus;
    Dispose(KS[channel]^.AutoBinData);
    KS[channel]^.AutoBinData:=NIL;
    exit;
  END;
  IF (savemode[channel]>0) and (KS[channel]^.AUtoBinData<>NIL) THEN
  BEGIN
    PopUP('finish other transfer first');
    exit;
  END;
  Which_Dialog:=1;
  {$IFDEF linux}
   DlgData[1]:=savpath+'*';
  {$ELSE} 
   DlgData[1]:=savpath+'*.*';
  {$ENDIF}
  DlgLabel(2,2,20,'File to Send:');
  DlgStr(2,3,40,@dlgdata[1]);
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' #BIN# - SendFile ');
  DlgInit(10,10,2);
END;

FUNCTION FileSelect(was:BYTE):BOOLEAN;
VAR  dir:PathStr;nam:String[20];ext:extSTR;
BEGIN
  FileSelect:=TRUE;
  IF (POS('*',DlgData[1])>0) OR (POS('?',DlgData[1])>0) THEN
  BEGIN
    Which_FileSelect:=was;
    FSplit(DlgData[1],dir,nam,ext);
    IF ext<>'.' THEN nam:=nam+ext;
    LastConsoleState:=ConsoleState;
    ConsoleState:=CONS_DIR;
    InitDir(dir,nam,fDlgInAktiv,FDlgInAktiv,fDlgBackGround,FDlgAktiv);
  END ELSE
    FileSelect:=FALSE;
END;

PROCEDURE SendAutoDlg_Auswert;
VAR sr:searchrec;st1,st2:string[10]; f:file;
    dir:PathStr;nam:String[20];ext:extSTR;
BEGIN
  Which_Dialog:=0;
  IF DlgResult>0 THEN
  BEGIN
   IF NOT FileSelect(1) THEN
     SendAuto(channel,DlgData[1]);
  END;
END;


PROCEDURE ReceiveAutoDlg;
BEGIN
  IF KS[channel]^.Status=14 THEN
  WITH KS[channel]^ DO
  BEGIN
    PutData(channel,'#ABORT#'+#13+#13);
    PutData(channel,'AUTOBIN-Transfer aborted by receiver '+#13);
    close(autobinData^.binfile);
    erase(AutoBinData^.binfile);
    dispose(autobindata);
    autobindata:=NIL;
    FLAGS := FLAGS OR KS_LINEMODE;
    FLAGS:=FLAGS OR KS_SHOWDATA;
    status:=laststatus;
    exit;
  END;
  IF (savemode[channel]>0) THEN
  BEGIN
    PopUP('close textfile first');
    exit;
  END;
  Which_Dialog:=5;
  DlgData[1]:=savpath;
  DlgLabel(2,2,20,'File to receive:');
  DlgStr(2,3,40,@dlgdata[1]);
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' #BIN# - ReceiveFile ');
  DlgInit(10,10,2);
END;

PROCEDURE ReceiveAutoDlg_Auswert;
VAR sr:searchrec;st1:string[10];
BEGIN
  Which_Dialog:=0;
  IF (KS[channel]^.Status=7) AND (Savemode[channel]=0) THEN
  IF DlgResult>0 THEN
  BEGIN
   IF NOT FileSelect(2) THEN
    ReceiveAuto(channel,DlgData[1]);
  END;
END;


PROCEDURE ReceiveText;
BEGIN
  IF Savemode[channel]=0 THEN
    ReceiveTextDlg
  ELSE BEGIN
    CLoseReceive(channel);
  END;
END;


PROCEDURE ReceiveTextDlg;
BEGIN
  Which_Dialog:=2;
  DlgData[1]:=savpath;
  DlgStr(2,3,40,@dlgdata[1]);
  DlgLabel(2,2,20,'filename    :');
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' receive file');
  DlgInit(10,10,1);
END;

PROCEDURE ReceiveTextDlg_Auswert;
VAR sr : SEARCHREC;
    st1: STRING[10];
BEGIN
  Which_Dialog:=0;
  IF DlgResult>0 THEN
  BEGIN
    IF NOT FileSelect(3) THEN
    ReceiveText2(channel,DlgData[1]);
  END;
END;

PROCEDURE ReceiveOverWriteDlg(s:string);
BEGIN
  Which_dialog:=21;
  DlgData[1]:=s;
  DlgText(2,2,s+' does already exist');
  DlgOkButton(2,3,1,' Append ');
  DlgOkButton(11,3,2,' Overwrite ');
  DlgAbortButton(23,3,' Cancel ');
  DlgTitle(' Receive File ');
  DlgInit(10,10,2);
END;

PROCEDURE ReceiveOverWriteDlg_AusWert;
BEGIN
  Which_Dialog:=0;
  CASE DlgResult OF
    1:ReceiveText2(channel,DlgData[1]+' +');
    2:ReceiveText2(channel,DlgData[1]+' !');
  END;
END;

PROCEDURE SendTextDlg;
BEGIN
  Which_Dialog:=3;
  DlgData[1]:=savpath+'*.*';
  DlgStr(2,3,40,@dlgdata[1]);
    DlgLabel(2,2,20,'filename    :');
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' send file ');
  DlgInit(10,10,1);
END;


PROCEDURE SendTextDlg_Auswert;
VAR sr : SEARCHREC;
    st1: STRING[10];
BEGIN
  Which_Dialog:=0;
  IF DlgResult>0 THEN
  BEGIN
    IF NOT FileSelect(4) THEN
     SendText(channel,dlgdata[1]);
  END;
END;

PROCEDURE KanalSettingsDlg;
BEGIN
  Which_Dialog:=4;
  dlgdata[2]:='';
  dlgbool:=KS[channel]^.compress=2;
  str(KS[channel]^.lev,Dlgdata[2]);
  DlgBool1:=(KS[channel]^.FLAGS AND KS_SYSOP)<>0;
  DlgBool2:=(KS[channel]^.FLAGS AND KS_AUTOSAVE)<>0;
  DlgBool3:=(KS[channel]^.FLAGS AND KS_INACTIVE)<>0;
  dlgbool4:=(KS[channel]^.flags AND KS_SAVESSID)<>0;
  DlgCheck(2,6,10,'Sysop     ',@DlgBool1);
  DlgCheck(2,7,10,'SP9-Comp  ',@DlgBool);
  DlgCheck(2,8,10,'Autosave  ',@DlgBool2);
  DlgCheck(2,9,10,'Inactive  ',@DlgBool3);
  DlgCheck(2,12,30,'Mit SSID speichern...  ',@DlgBool4);
  DlgOkButton(25,13,1,' OK ');
  DlgAbortButton(19,13,'ABORT');
  DlgTitle('Channel Settings');
  DlgInit(25,4,1);
END;

PROCEDURE KanalSettingsDlg_Auswert;
VAR B:BYTE;
BEGIN
  Which_Dialog:=0;
  VAL(DlgData[2],KS[channel]^.lev,err);
  IF (DlgBool) and (KS[channel]^.Compress<>2) THEN
    KS[channel]^.compress:=2
  ELSE
  IF (not DlgBool) and (KS[channel]^.Compress=2) THEN
    KS[channel]^.Compress:=0;
  IF DlgBool1 THEN
    KS[channel]^.FLAGS := KS[channel]^.FLAGS OR KS_SYSOP
  ELSE
    KS[channel]^.FLAGS := KS[channel]^.FLAGS AND NOT KS_SYSOP;
  IF DlgBool2 THEN
    KS[channel]^.FLAGS := KS[channel]^.FLAGS OR KS_AUTOSAVE
  ELSE
    KS[channel]^.FLAGS := KS[channel]^.FLAGS AND NOT KS_AUTOSAVE;
  IF DlgBool3 THEN
    KS[channel]^.FLAGS := KS[channel]^.FLAGS OR KS_INACTIVE
  ELSE
    KS[channel]^.FLAGS := KS[channel]^.FLAGS AND NOT KS_INACTIVE;
  IF DlgBool4 THEN
    KS[channel]^.FLAGS := KS[channel]^.FLAGS OR KS_SAVESSID
  ELSE
    KS[channel]^.FLAGS := KS[channel]^.FLAGS AND NOT KS_SAVESSID;
  SaveTermUser(channel);
END;

PROCEDURE MCUTEndeDlg;
BEGIN
  Which_Dialog:=11;
  DlgCheck(2,2,30,'save settings.',@SaveSettings);
  DlgOkButton(2,3,1,' OK ');
  DlgAbortButton(8,3,'ABORT');
  DlgTitle(' exit MCUT  ');
  DlgInit(22,10,3);
END;

PROCEDURE MCUTEndeDlg_Auswert;
VAR B:BYTE;
BEGIN
  Which_Dialog:=0;
  IF DlgResult>0 THEN MCUT_Ende:=TRUE;
END;

PROCEDURE CallChangeDlg;
BEGIN
  Which_Dialog:=13;
  IF KS[channel]=NIL THEN exit;
  DLgData[1]:=KS[channel]^.Call;
  DlgStr(2,2,10,@DlgData[1]);
  DlgOkButton(2,3,1,' OK ');
  DlgAbortButton(8,3,'ABORT');
  DlgTitle(' Rufzeichen ndern ');
  DlgInit(22,10,1);
END;

PROCEDURE CallChangeDlg_Auswert;
VAR B:BYTE;
BEGIN
  Which_Dialog:=0;
  IF KS[channel]=NIL THEN
    exit;
  KS[channel]^.CALL:=dlgdata[1];
  LoadTermUser(channel);
END;

PROCEDURE UserSettingsDlg;
BEGIN
  Which_Dialog:=14;
  IF KS[channel]<>NIL THEN
    dlgData[1]:=KS[channel]^.call
  ELSE
    dlgData[1]:='';
  DlgStr(2,2,10,@DlgData[1]);
  DlgOkButton(2,3,1,' OK ');
  DlgAbortButton(8,3,'ABORT');
  DlgTitle(' Callsign to edit? ');
  DlgInit(20,5,1);
END;

PROCEDURE UserSettingsDlg_Auswert;
BEGIN
  DLg_u.call:=DlgData[1];
  IF dlgdata[1]='' THEN
  BEGIN
    Which_dialog:=0;
    exit;
  END;
  UserSettingsDlg2;
END;


PROCEDURE UserSettingsDlg2;
BEGIN
  IF (NOT GetTermUser(dlg_u)) THEN
    IF (KS[channel]<>NIL) AND (dlg_u.call=cutssid(KS[channel]^.call)) THEN
    dlg_u.flags:=KS_2_TU(KS[channel]^.Flags,dlg_u.flags);
  Which_Dialog:=15;
  DlgStr(2,3,21,@dlg_u.name);
  DlgLabel(2,2,21,'Name:');
  DlgStr(2,5,10,@dlg_u.einstieg);
  DlgLabel(2,4,25,'Entry digipeater:');
  DlgStr(2,7,10,@dlg_u.netzwerk);
  DlgLabel(2,6,25,'Network-ID for routing:');
  Str(dlg_u.level,dlgdata[1]);
  DlgIntStr(2,9,3,@DlgData[1]);
  DlgLabel(2,8,25,'Level ');
  DlgStr(2,12,70,@dlg_u.directory);
  DlgLabel(2,11,40,'List of Directories for //-access');
  DlgCheckBit(40,2,30,'Sysop allowed ',@dlg_u.flags,TU_SYSOP);
  DlgCheckBit(40,3,30,'7+/BIN-Autosave   ',@dlg_u.flags,TU_AUTOSAVE);
  DlgCheckBit(40,4,30,'recognize "connected to"',@dlg_u.flags,TU_CONNECT);
  DlgCheckBit(40,5,30,'recognize "reconnected to"',@dlg_u.flags,TU_RECONNECT);
  DlgCheckBit(40,6,30,'Autosend passwords',@dlg_u.flags,TU_SENDPW);
  DlgCheckBit(40,7,30,'remote access',@dlg_u.flags,TU_REMOTE);
  DlgCheckBit(40,8,30,'Mailbox',@dlg_u.flags,TU_BBS);
  DlgCheckBit(40,9,30,'excluded',@dlg_u.flags,TU_EXCLUDED);
  DlgCheckBit(40,10,30,'save call with SSID',@dlg_U.flags,TU_SAVESSID);
  DlgOkButton(2,15,1,' Save ');
  DlgOkButton(12,15,2,' Remotes... ');
  DlgOkButton(26,15,3,' Other...');
  DlgABortButton(50,15,' Abort ');
  DlgTitle(' Settings for '+dlg_u.call+' ');
  DlgInit(2,5,1);
END;

PROCEDURE UserSettingsDlg2_Auswert;
VAR err:INTEGER;
BEGIN
  CASE dlgResult OF
    1:BEGIN
        val(dlgdata[1],dlg_u.level,err);
        SetTermUser(dlg_u);
        IF KS[channel]<>NIL THEN
        BEGIN
          IF (KS[channel]^.FLAGS AND KS_SAVESSID)<>0 THEN
          BEGIN
            str(dlg_u.ssid,ein_s);
            IF (dlg_u.call+'-'+ein_s)=KS[channel]^.Call THEN
              LoadTermUser(channel);
          END ELSE
          BEGIN
            IF (dlg_u.call)=cutssid(KS[channel]^.Call) THEN
              LoadTermUser(channel);
          END;
        END;
        Which_Dialog:=0;
      END;
    2:UserSettingsRemotesDlg;
    3:UserSettingsOtherDlg;
  END;
END;

PROCEDURE UserSettingsRemotesDlg;
BEGIN
  Which_Dialog:=16;
  DlgCheckBit(2,2,20,'QUIT',@dlg_u.REMOTES,RM1_QUIT);
  DlgCheckBit(2,3,20,'RING',@dlg_u.REMOTES,RM1_RING);
  DlgCheckBit(2,4,20,'ECHO',@dlg_u.REMOTES,RM1_ECHO);
  DlgCheckBit(2,5,20,'RTT',@dlg_u.REMOTES,RM1_RTT);
  DlgCheckBit(2,6,20,'INFO',@dlg_u.REMOTES,RM1_INFO);
  DlgCheckBit(2,7,20,'CSTATUS',@dlg_u.REMOTES,RM1_CS);
  DlgCheckBit(2,8,20,'USER',@dlg_u.REMOTES,RM1_USER);
  DlgCheckBit(2,9,20,'HELP',@dlg_u.REMOTES,RM1_HELP);
  DlgCheckBit(2,10,20,'SYSOP',@dlg_u.REMOTES,RM1_SYSOP);
  DlgCheckBit(2,11,20,'DIR',@dlg_u.REMOTES,RM1_DIR);
  DlgCheckBit(2,12,20,'READ',@dlg_u.REMOTES,RM1_READ);
  DlgCheckBit(2,13,20,'WRITE',@dlg_u.REMOTES,RM1_WRITE);
  DlgCheckBit(2,14,20,'RPRG',@dlg_u.REMOTES,RM1_RPRG);
  DlgCheckBit(2,15,20,'WPRG',@dlg_u.REMOTES,RM1_WPRG);
  DlgCheckBit(36,2,20,'NAME',@dlg_u.REMOTES,RM1_NAME);
  DlgCheckBit(36,3,20,'MHEARD',@dlg_u.REMOTES,RM1_MH);
  DlgCheckBit(36,4,20,'RUN',@dlg_u.REMOTES,RM1_RUN);
  DlgCheckBit(36,5,20,'BOX',@dlg_u.REMOTES,RM1_BOX);
  DlgCheckBit(36,6,20,'DOS',@dlg_u.REMOTES,RM1_DOS);
  DlgCheckBit(36,7,20,'NODE',@dlg_u.REMOTES,RM1_NODE);
  DlgCheckBit(36,8,20,'CONNECT',@dlg_u.REMOTES,RM1_CONNECT);
  DlgCheckBit(36,9,20,'COMPRESS',@dlg_u.REMOTES,RM1_COMPRESS);
  DlgCheckBit(36,10,20,'VERSION',@dlg_u.REMOTES,RM1_VERSION);
  DlgCheckBit(36,11,20,'TIME',@dlg_u.REMOTES,RM1_TIME);
  DlgCheckBit(36,12,20,'XRUN',@dlg_u.REMOTES,RM1_XRUN);
  DlgCheckBit(36,13,20,'REBOOT',@dlg_u.REMOTES,RM1_REBOOT);
  DlgCheckBit(36,14,20,'TNC',@dlg_u.REMOTES,RM1_TNC);
  DlgCheckBit(36,15,20,'FORCE',@dlg_u.REMOTES,RM1_FORCE);
  DlgCheckBit(36,16,20,'CONVERS',@dlg_u.REMOTES,RM1_CONVERS);
  DlgOkButton(2,17,1,' Save ');
  DlgOkButton(12,17,2,' General... ');
  DlgOkButton(26,17,3,' Other...');
  DlgABortButton(50,17,' Abort ');
  DlgTitle('Settings for '+dlg_u.call);
  DlgInit(5,2,1);
END;

PROCEDURE UserSettingsRemotesDlg_Auswert;
BEGIN
  CASE dlgResult OF
    1:BEGIN
        SetTermUser(dlg_u);
        Which_Dialog:=0;
        IF KS[channel]<>NIL THEN
        BEGIN
          IF (KS[channel]^.FLAGS AND KS_SAVESSID)<>0 THEN
          BEGIN
            str(dlg_u.ssid,ein_s);
            IF (dlg_u.call+'-'+ein_s)=KS[channel]^.Call THEN
              LoadTermUser(channel);
          END ELSE
          BEGIN
            IF (dlg_u.call)=cutssid(KS[channel]^.Call) THEN
              LoadTermUser(channel);
          END;
        END;

      END;
    2:UserSettingsDlg2;
    3:UserSettingsOtherDlg;
  END;
END;



PROCEDURE UserSettingsPasswordsDlg_Auswert;
BEGIN
  CASE dlgResult OF
    1:BEGIN
        SetTermUser(dlg_u);
        Which_Dialog:=0;
        IF KS[channel]<>NIL THEN
        BEGIN
          IF (KS[channel]^.FLAGS AND KS_SAVESSID)<>0 THEN
          BEGIN
            str(dlg_u.ssid,ein_s);
            IF (dlg_u.call+'-'+ein_s)=KS[channel]^.Call THEN
              LoadTermUser(channel);
          END ELSE
          BEGIN
            IF (dlg_u.call)=cutssid(KS[channel]^.Call) THEN
              LoadTermUser(channel);
          END;
        END;

      END;
    2:UserSettingsDlg2;
    3:UserSettingsOtherDlg;
  END;

END;

PROCEDURE UserSettingsOtherDlg;
BEGIN
Which_Dialog:=0;
END;

PROCEDURE UserSettingsOtherDlg_Auswert;
BEGIN
END;

END.
