
{$M 60000,0,0}
USES Toolbox,mystring,crt,dos;
var F,cons:TEXT;S,S2,suchstr,filename:STRING;start,matches:LONGINT;
    regexp:BOOLEAN;B:BYTE;left,right,err:word;

CONST
  count_only:BOOLEAN=FALSE;
  case_sense:BOOLEAN=FALSE;

{TRUE, wenn das bergebene Zeichen eine Zahl ist.}
FUNCTION IsZahl(ch: CHAR): BOOLEAN;
BEGIN
  IsZahl := (ch<'9') AND (ch>'0');
END;



{TRUE, wenn das bergebene Zeichen ein Buchstabe ist.}
FUNCTION IsBuchstabe(ch: CHAR): BOOLEAN;
BEGIN
  IsBuchstabe := ((ch AND 223)>'a') AND ((ch AND 223)<'z');
END;


{Testet 2 Strings, ob die bereinstimmen. Hier ist kein '*' mehr vorhanden.}
FUNCTION StringMatch(Norm,Wild: STRING): BOOLEAN;
VAR i,j: BYTE;
BEGIN
  j:=0;
  StringMatch:=FALSE;
  FOR i := 1 TO Byte(wild[0]) DO
  BEGIN
    inc(j);
    {ein slash fhrt dazu, da das folgende zeichen nicht als wildcard angesehen
     wird}
    IF wild[i]='\' THEN
    BEGIN
      inc(i);
      IF i>byte(wild[0]) THEN exit;
      IF (Norm[j]<>Wild[i])  THEN exit;
    END
    ELSE
    IF NOT (
       (Norm[j]=Wild[i]) OR (Wild[i]='?') OR
       ((wild[i]='#') AND (norm[j]>='0') AND (norm[j]<='9')) OR
       ((wild[i]='@') AND ((byte(norm[j]) AND 223) >= ord('A')) AND ((byte(norm[j]) AND 223) <= ord('Z')))) THEN
         exit;
  END;
  StringMatch := TRUE;
END;

FUNCTION TrueLen(VAR S:STRING):BYTE;ASSEMBLER;
ASM
    CLD
    PUSH DS
    MOV BX,0
    LDS SI,S              {Adresse von S nach DS:SI}
    XOR CX,CX
    MOV CL,DS:[SI]        {Lngen-Byte nach CX}
    JCXZ @Fertig
    INC SI                {SI := SI + 1}
   @Schleife:
    MOV AH,DS:[SI]
    INC SI
    CMP AH,'\'
    JE @weiter
   @incr:
    INC BX
    LOOP @schleife
    JMP @fertig
   @weiter:
    DEC SI
    DEC SI
    MOV AH,DS:[SI]
    INC SI
    INC SI
    CMP AH,'\'
    JE @incr
    LOOP @Schleife
   @Fertig:
    MOV AX,BX
    POP DS
END;


{Guckt, ob der String Norm mit dem String Wild berein stimmt. In Wild knnen
 Wildcards vorkommen (das machts etwas komplizierter). Ich wrde mich freuen,
 wenn Du die Routine etwas besser und vor allem schneller neu schreibst, wenn
 das mglich ist.}
FUNCTION Match(Norm,Wild: STRING): BOOLEAN;
VAR S,norm2: STRING;
    i,len1,len2: BYTE;
    OK: BOOLEAN;
    L,R:STRING;
BEGIN
  Match := FALSE;
  IF LENGTH(Wild)=0 THEN BEGIN
    IF Norm='' THEN
       Match := TRUE;
    Exit;
  END;
  IF find(wild,'*',L,R) THEN
  BEGIN
    len1:=truelen(l);
    norm2:=copy(norm,len1+1,255);
    IF match(copy(norm,1,len1),L) THEN
    BEGIN
      WHILE FIND(norm2,r[1],L,norm2) DO
      IF match(r[1]+norm2,R) OR (R='') THEN
      BEGIN
        match:=TRUE;
        exit;
      END;
    END;
  END ELSE
  Match := StringMatch(Norm,Wild)
END;


FUNCTION TypeMatch(Typ,Wild: CHAR): BOOLEAN;
BEGIN
  TypeMatch := TRUE;
  IF (Wild='*') OR
     (WILD='?') OR
     ((Wild='#') AND (typ>='0') AND (typ<='9')) OR
     ((Wild='@') AND ((byte(typ) AND 223)>=ord('a')) AND ((byte(typ) AND 223)<=ord('z'))) THEN Exit;
  IF Typ<>Wild THEN TypeMatch := FALSE;
END;

FUNCTION vergleichen(s1,s2:STRING):BOOLEAN;
VAR b:BYTE;dummy:string[1];
BEGIN
  WHILE (S1[1]='*') AND (S1[0]>#0) DO Delete(s1,1,1);
  WHILE (S1[LENGTH(s1)]='*') AND (S1[0]>#0) DO Delete(s1,LENGTH(s1),1);
  vergleichen:=false;
  FOR b:=1 to length(s2) DO
    IF match(copy(s2,b,255),s1) THEN
    BEGIN
      vergleichen:=TRUE;
      exit;
    END;
END;

VAR SR:SEARCHREC;state:BYTE;
label x;
BEGIN
  start:=currixtime;
  matches:=0;
  filename:=paramstr(1);
  regexp:=FALSE;
  assign(output,'');
  rewrite(output);
  System.WriteLn('SUCH 0.2 960411 DG4IAD');
  System.Writeln('universal list-examiner');
  right:=255;left:=0;
  IF paramcount<2 THEN
  BEGIN
    System.WriteLn;

    System.WriteLn('SYNTAX : SUCH [-j|s|c|r<value>|l<value>] database expression');
    System.WriteLn(' -j = use joker-expression [not really unix-like]');
    System.WriteLn(' -s = search case-sensitive');
    System.WriteLn(' -c = count only ');
    System.WriteLn(' -l = define left margin');
    System.WriteLn(' -r = define right margin');
    system.Writeln;
    system.WritelN('Jokers:');
    system.writeln(' * matches any substring');
    system.writeln(' ? matches any single character');
    system.writeln(' @ matches any character (A..Z,a..z)');
    system.writeln(' # matches any number (0..9)');

    system.writeln('Available databases:');
    FindFirst('\listen\*.lst',anyfile,sr);
    WHILE doserror=0 DO
    BEGIN
      system.WriteLn(copy(sr.name,1,length(sr.name)-4));
      findnext(sr);
    END;
    exit;
  END;
  state:=0;
  S2:=LTRIM(String(ptr(prefixseg,$80)^))+' ';
  WHILE FIND(s2,' ',suchstr,s2) DO
  BEGIN
    s2:=ltrim(s2);
    IF suchstr[1]='-' THEN
    BEGIN
      FOR B:=2 to length(suchstr) DO
      CASE upcase(suchstr[b]) OF
        'J':regexp:=TRUE;
        'S':case_sense:=TRUE;
        'C':count_only:=TRUE;
        'R':IF b<length(suchstr) THEN
             BEGIN
               INC(b);
               S:='';
               WHILE (suchstr[b] IN ['0'..'9']) AND (b<=length(suchstr)) DO
               BEGIN
                 S:=S+suchstr[b];
                 INC(b);
               END;
               Dec(b);
               VAL(s,right,err);
             END;
        'L':IF b<length(suchstr) THEN
             BEGIN
               INC(b);
               S:='';
               WHILE (suchstr[b] IN ['0'..'9']) AND (b<=length(suchstr)) DO
               BEGIN
                 S:=S+suchstr[b];
                 INC(B);
               END;
               dec(b);
               VAL(s,left,err);
             END;
      ELSE
        system.writeln('Invalid Parameter '+upcase(suchstr[b]));
        halt;
      END;
    END ELSE
    IF state=0 THEN
    BEGIN
      filename:=suchstr;
      inc(state);
    END ELSE
    IF state=1 THEN
    BEGIN
      suchstr:=rtrim(suchstr+' '+s2);
      goto x;
    END;
  END;
 X:
  ASSIGN(f,'\listen\'+filename+'.LST');
  {$I-}
  RESET(f);
  IF IORESULT<>0 THEN
  BEGIN
    system.writeln(gross(filename)+' not found');
    flush(cons);
    halt;
  END;
  {$I+}
  IF not case_sense THEN suchstr:=gross(suchstr);
  system.writeLn('searching for       :'+suchstr);
  system.writeln('regular expressions :',regexp);
  system.writeln('case sensitive      :',case_sense);
  system.writeln('count only          :',count_only);
  system.writeln('left/right margin   :',left,'/',right);
  WHILE NOT EOF(f) DO
  BEGIN
    ReadLn(f,s);
    IF not case_sense THEN s2:=copy(gross(s),left,right)
      ELSE s2:=copy(s,left,right);
    IF regexp THEN
    BEGIN
      IF vergleichen(suchstr,s2) THEN
      BEGIN
        inc(matches);
        IF not count_only THEN
          system.writeln(s);
         flush(output);
        inoutres:=0;
      END;
    END ELSE
    BEGIN
      IF pos(suchstr,s2)>0 THEN
      BEGIN
        inc(matches);
        IF not count_only THEN
          system.writeln(s);
        flush(output);
        inoutres:=0;
      END;
    END;
  END;
  system.writeln(round(matches),' hits, time:'+mkTstr(currixtime-start));
  close(f);
END.