UNIT TERMSCAN;

INTERFACE
USES IADVAR;

CONST
  MaxTyp=9;

  DigiFlagsAn=KS_CONNECT+KS_RECONNECT;
  DigiFlagsAus=KS_AUTOSAVE+KS_REMOTE+KS_BBS;
  BBSFlagsAn=KS_BBS+KS_AUTOSAVE+KS_RECONNECT;
  BBSFlagsAus=KS_CONNECT;
  TermFlagsAn=KS_REMOTE+KS_RECONNECT+KS_AUTOSAVE;
  TermFlagsAus=KS_BBS;
  ClusterFlagsAn=KS_AUTOSAVE;
  ClusterFlagsAus=KS_REMOTE+KS_CONNECT+KS_RECONNECT;
  UnixFlags=KS_RECONNECT+KS_AUTOSAVE;
  FlagsAn:ARRAY[1..MaxTyp] OF LONGINT = ( DigiFlagsAn, BBSFlagsAn,
                      BBSFlagsAn, BBSFlagsAn, BBSFlagsAn, BBSFlagsAn,
                       BBSFlagsAn, BBSFlagsAn, ClusterFlagsAn);
  FlagsAus:ARRAY[1..MaxTyp] OF LONGINT = ( DigiFlagsAus, BBSFlagsAus,
                      BBSFlagsAus, BBSFlagsAus, BBSFlagsAus, BBSFlagsAus,
                       BBSFlagsAus, BBSFlagsAus, ClusterFlagsAus);
  FUNCTION KS_2_TU(l:LONGINT;l2:LONGINT):LONGINT;
  FUNCTION TU_2_KS(l:LONGINT;l2:LONGINT):LONGINT;
  FUNCTION scan(c:BYTE;S:STRING):BOOLEAN;
  PROCEDURE PwScan(c:byte;s:string;second:BOOLEAN);
  FUNCTION GenPwd(c:BYTE):STRING;

IMPLEMENTATION

USES MyString,ToolBox,
  {$IFNDEF LINUX} memory ,{$ENDIF}dos,screen;


FUNCTION GenPwd(c:BYTE):STRING;
VAR B:BYTE;
    RMNC:LONGINT;
    VergleichPW,S,call:STRING;
    r,l:STRING[15];
    PWFile:TEXT;OK:BOOLEAN;
    err:INTEGER;
    min,tag,std,monat,jahr,
    offset,spalte,zeile:WORD;
    dbf:FILE;
    Multi:ARRAY[1..5] OF BYTE;
    Zs:ARRAY[1..5] OF LONGINT;
    Multi_Zeiger:BYTE;
    ch:char;
    
BEGIN
  GenPwd:='';
  IF KS[c]=NIL THEN exit;
  IF (KS[c]^.LOOP>0) AND (c>maxTerminal) THEN
     exit;
  IF KS[c]^.PWtyp=3 THEN BEGIN
    VAL(copy(KS[c]^.pw,13,2),min,err);
    VAL(copy(KS[c]^.pw,10,2),std,err);
    VAL(copy(KS[c]^.pw,1,2),tag,err);
    VAL(copy(KS[c]^.pw,4,2),monat,err);
    VAL(copy(KS[c]^.pw,7,2),jahr,err);
    ASSIGN(DBF,qrvpath+Cutssid(KS[c]^.Call)+'.pwd');
    {$I-}
    RESET(DBF,1);
    {$i+}
    IF IOResult<>0 THEN
    BEGIN
      ASSIGN(DBF,qrvpath+Cutssid(KS[c]^.Call)+'.pwx');
      {$I-}
      RESET(DBF,1);
      {$i+}
      IF IOResult<>0 THEN exit;
      (* Ok, scheinbar wird das "neue" DieBox-Verfahren verwendet... ach
         du graus. *)
      Offset:=(min+1) * 27;
      Multi[1]:=3;Multi[2]:=5;Multi[3]:=7;Multi[4]:=9;Multi[5]:=11;
      seek(dbf,offset-1);   
      IF FileSize(dbf)<5 THEN
      BEGIN
        close(dbf);exit;
      END;  
      Multi_Zeiger:=0;
      REPEAT
        If FilePos(dbf)=FileSize(dbf) THEN seek(dbf,0);
        BlockRead(dbf,ch,1);
        IF ch IN ['0'..'9'] THEN
        BEGIN
          Inc(Multi_Zeiger);
          Multi[Multi_Zeiger]:=Byte(ch)-48;
        END;
      UNTIL  (Multi_Zeiger=5) OR (FilePos(dbf)=offset-1);  
      Zs[1]:=(std*Multi[1]+min*Multi[2]+Tag*Multi[3]+Monat*Multi[4]+jahr*jahr*Multi[5]+Multi[3]*Multi[4]) MOD 1620;
      Zs[2]:=(std*Multi[2]+min*Multi[4]+Tag*Multi[1]+Monat*Multi[5]+jahr*jahr*Multi[3]+Multi[1]*Multi[5]) MOD 1620;
      Zs[3]:=(std*Multi[3]+min*Multi[1]+Tag*Multi[5]+Monat*Multi[2]+jahr*jahr*Multi[4]+Multi[2]*Multi[3]) MOD 1620;
      Zs[4]:=(std*Multi[4]+min*Multi[5]+Tag*Multi[2]+Monat*Multi[3]+jahr*jahr*Multi[1]+Multi[4]*Multi[5]) MOD 1620;
      Zs[5]:=(std*Multi[5]+min*Multi[3]+Tag*Multi[4]+Monat*Multi[1]+jahr*jahr*Multi[2]+Multi[1]*Multi[3]) MOD 1620;
      FOR tag:=1 TO 5 DO BEGIN
        Seek(dbf,Zs[tag]);BlockRead(dbf,S[tag],1);
      END;
      close(dbf);
      s[0]:=#5;
      randomize;
      FOR B:=1 TO 35 DO
      BEGIN
        VergleichPW[b]:=Char(random(122)+33);
        IF VergleichPW[b]=';' THEN VergleichPW[b]:='t';
      END;
      VergleichPW[0]:=#35;
      Insert(S,VergleichPW,Random(34)+1);
      GenPwd:='PRIV '+VergleichPW;
      exit;  
    END;
    offset:=min+tag;
    if offset>59 THEN dec(offset,60);
    offset:=(offset*27)+std;
    SEEK(dbf,offset);
    BlockRead(dbf,s[1],4);
    s[0]:=#4;
    GenPwd:='PRIV '+S;
    CLOSE(DBF);
    EXIT;
  END;

   ASSIGN(PWFile,qrvpath+'passwd.mct');
  {$I-}
  RESET(PWFile);
  {$i+}
  OK:=FALSE;
  GenPwd:='';
  IF IOResult<>0 THEN exit;
  WHILE NOT EOF(PWFile) AND NOT OK DO
  BEGIN
    READLN(PWFile,S);
    IF FIND(S,'=',call,VergleichPW) THEN
      IF gross(call)=KS[c]^.Call THEN
         OK:=TRUE;
  END;
  CLOSE(PWFile);
  IF NOT OK THEN exit;
  CASE KS[c]^.PWtyp OF
     1:BEGIN
         WHILE length(KS[c]^.pw)<5 DO
           KS[c]^.pw:='0'+KS[c]^.pw;
         RMNC:=0;
         FOR B:=1 to 5 DO
           inc(rmnc,(BYTE(KS[c]^.pw[b])-48)*(BYTE(VergleichPW[b])-48));
         Str(rmnc,s);
         GenPwd:=s;
       END;
     2:BEGIN
         S:='' ;
         r:=KS[c]^.pw+' ';
         WHILE FIND(r,' ',l,r) DO
         BEGIN
           VAL(l,b,err);
           S:=S+VergleichPW[b];
         END;
         VergleichPW[0]:=#35;
         randomize;
         FOR B:=1 TO 35 DO
         BEGIN
           VergleichPW[b]:=Char(random(122)+33);
           IF VergleichPW[b]=';' THEN VergleichPW[b]:='t';
         END;
         Insert(s,vergleichpw,random(34)+1);
         GenPwd:=VergleichPW;
      END;
    4:BEGIN
{$IFNDEF linux}
	 SetMemTop(HeapPtr);
        EXEC(getenv('COMSPEC'),'/C '+qrvpath+'MD2 '+KS[c]^.PW+' '+vergleichpw+' > '+qrvpath+'MD2.$$$');

	 SetMemTop(HeapEnd);
{$ENDIF}
	 {$I-}
        ASSIGN(PWfile,qrvpath+'MD2.$$$');
        RESET(PWFILE);
        IF IORESULT<>0 THEN
        BEGIN
          PopUp('Error generating MD2 password');
          exit;
        END;
        ReadLn(PWFile,S);
        CLOSE(PWFile);
        GenPwd:=s;
      END;
  END;
END;
{$IFDEF linux}
FUNCTION FindStringStartPos(S1,S2 : STRING):BYTE;
BEGIN
   FindStringStartPos:=POS(S2,S1);
END; { FindStringStartPos }
{$ENDIF}
(*
 *  Diese Routine scant die Daten nach Passwort-Prompts und legt das
 *  erkannte passwort-prompt in ks[c]^.pw ab *)

PROCEDURE PwScan(c:byte;s:string;second:BOOLEAN);
VAR W:WORD;l,r,s2:STRING;B,anzspace:BYTE;
    err:integer;longpw:LONGINT;ok:BOOLEAN;
BEGIN
  IF (KS[c]^.LOOP>0) AND (c>maxTerminal) THEN
     exit;
  IF KS[c]<>NIL THEN
  BEGIN
    W:=FindStringStartPos(S,'Login:');
    IF ((W>0)) THEN
    BEGIN
      S:=copy(s,w,255);
      IF (S[0]>#19) AND (S[10]='.') AND (S[13]='.') AND (S[16]=' ') AND
         (S[19]=':') THEN
      BEGIN
        KS[c]^.pw:=copy(s,8,14);
        KS[c]^.pwtyp:=3;
        Exit;
      END;
    END;
    IF S[length(s)] IN [#10,#13] THEN dec(byte(s[0]));
    IF Find(s,'>',l,r) THEN
    BEGIN
      IF (L='=') THEN
        IF NOT FIND(r,'>',l,r) THEN exit;
      IF ((L[1]='(') AND (r='')) THEN
      BEGIN
        IF FIND(l,')',l,r) THEN
        BEGIN
          r:=ltrim(r);
          IF (r[0]<#6) and (r[0]>#2) THEN
          BEGIN
            val(r,longpw,err);
            IF err=0 THEN
            BEGIN
              IF KS[c]^.pw=r THEN exit;
              KS[c]^.PwTyp:=1;
              KS[c]^.pw:=r;
              IF (KS[c]^.FLAGS  AND KS_SENDPW)<>0 THEN
              BEGIN
                S:=GenPwd(c);
                IF s<>'' THEN
                  PutData(c,s+#13);
              END;
              exit;
            END;
          END;
        END;
      END;
      IF NOT FIND(l,':',s2,l) THEN L:=s2;
      IF Checkcall(cutssid(l)) THEN
      BEGIN
        anzspace:=0;
        OK:=TRUE;
        r:=ltrim(rtrim(r));
        FOR B:=1 to length(r) DO
        BEGIN
          IF r[b]=' ' THEN inc(anzspace) ELSE
            IF (r[b]>'9') AND (r[b]<'0') THEN
              OK:=FALSE;
        END;
        IF (OK) AND (anzspace=4) THEN
        BEGIN
          KS[c]^.Pwtyp:=2;
          IF KS[c]^.pw=r THEN exit;
          KS[c]^.pw:=r;
          IF (KS[c]^.FLAGS  AND KS_SENDPW)<>0 THEN
          BEGIN
            S:=GenPwd(c);
            IF s<>'' THEN
              PutData(c,s+#13);
          END;
        END ELSE
        IF (r[1]='[') AND (r[length(r)]=']') THEN
        BEGIN
          KS[c]^.Pwtyp:=4;
          r:=copy(r,2,length(r)-2);
          IF KS[c]^.pw=r THEN exit;
          KS[c]^.pw:=r;
          IF (KS[c]^.FLAGS  AND KS_SENDPW)<>0 THEN
          BEGIN
            S:=GenPwd(c);
            IF s<>'' THEN
              PutData(c,s+#13);
          END;
        END;
      END;
    END;
  END;
END;


FUNCTION scan(c:BYTE;S:STRING):BOOLEAN;
VAR W:WORD;
BEGIN
  (*
   * Zunchst prfen, ob die Userdaten gespeichert sind, oder
   * "erraten" werden mssen...
   *)
  scan:=TRUE;
  IF (KS[c]^.typ=0) THEN
  BEGIN
    (*
     * RMNC/FlexNet oder  PC/FlexNet (leicht zu scannen)
     *)
    W:=FindStringStartPos(S,'/FlexNet');
    IF  ((W=3) OR (W=5)) THEN
    BEGIN
      IF ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
        KS[c]^.Flags:=(KS[c]^.FLAGS OR DigiFlagsAn) AND (NOT DigiFlagsAus);
      KS[c]^.Typ:=1;
      Exit;
    END;
    (*
     * BayBox: Hat immer als erstes Wort im CTEXT "BayCom-Mailbox" stehen.
     *)
    W:=FindStringStartPos(S,'BayCom-Mailbox');
    IF  (W=1) THEN
    BEGIN
     IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
        KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
      KS[c]^.Typ:=2;
      pwscan(c,s,false);
      Exit;
    END;
    (*
    W:=FindStringStartPos(S,'Mailbox');
    IF (W=1) THEN
    BEGIN
      IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
        KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
      KS[c]^.Typ:=0;
      Exit;
    END;*)
    (*
     * DPBox: Hat ein SID -> no problems
     *)
    W:=FindStringStartPos(S,'[DP-');
    IF  (W=1) THEN
    BEGIN
      IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
        KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
      KS[c]^.Typ:=5;
      Exit;
    END;
    (*
     * F6FBB: wird am SID erkannt.
     *)
    W:=FindStringStartPos(S,'[FBB-');
    IF (W=1) THEN
    BEGIN
      IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
        KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
      KS[c]^.Typ:=6;
      Exit;
    END;
    W:=FindStringStartPos(S,'[MCT-');
    IF (W=1) THEN
    BEGIN
      IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
        KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
      KS[c]^.Typ:=7;
      Exit;
    END;
    (*
     * DieBox: die Zeile 'Login: TT.MM.JJ MM:SS  TZ   Logins: x' scheint
     * grundstzlich vorgegeben zu sein. Wenn sie exakt nach diesem Muster
     * auftritt, gehe ich von einer DieBox aus.
     * DPBox,FBB und BayCom werden soundso sicher an der ersten zeile
     * erkannt, erreichen diesen Test hier also garnicht.
     *)
    W:=FindStringStartPos(S,'Login:');
    IF ((W>0)) THEN
    BEGIN
      S:=copy(s,w,255);
      IF (S[0]>#19) AND (S[10]='.') AND (S[13]='.') AND (S[16]=' ') AND
         (S[19]=':') THEN
      BEGIN
        IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
          KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
        KS[c]^.Typ:=4;
        Exit;
      END;
    END;
    (* WAMPES/BBSx
     *)
    W:=FindStringStartPos(S,'Last login: ');
    IF (W=1) THEN
    BEGIN
      W:=FindStringStartPos(S,' from ');
      IF W>10 THEN
      BEGIN
        IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
          KS[c]^.Flags:=(KS[c]^.FLAGS OR BBSFlagsAn) AND NOT BBSFlagsAus;
        KS[c]^.Typ:=10;
        Exit;
      END;
    END;

    (*
     * DXCluster, ebenfalls etwas kompliziert. Ich versuche das
     * Prompt zu erkennen.
     *)
    W:=FindStringStartPos(S,'? >');
    IF ((W>0)) THEN
    BEGIN
      W:=FindStringStartPos(S,cutssid(mcall[c]^)+' de');
      IF (w=1) THEN
      BEGIN
        IF  ((KS[c]^.FLAGS AND KS_UNKNOWN)<>0) THEN
          KS[c]^.Flags:=(KS[c]^.FLAGS OR ClusterFlagsAn) AND NOT ClusterFlagsAus;
        KS[c]^.Typ:=9;
        Exit;
      END;
    END;
  END;
  pwscan(c,s,false);
  scan:=FALSE;
END;       

FUNCTION TU_2_KS(l:LONGINT;l2:LONGINT):LONGINT;
BEGIN
  IF (l and TU_AUTOSAVE)<>0 THEN
   l2:=l2 OR KS_AUTOSAVE ELSE
     l2:=l2 AND NOT KS_AUTOSAVE;
  IF (l and TU_CONNECT)<>0 THEN
     l2:=l2 OR KS_CONNECT ELSE
     l2:=l2 AND NOT KS_CONNECT;
  IF (l and TU_RECONNECT)<>0 THEN
     l2:=l2 OR KS_RECONNECT ELSE
     l2:=l2 AND NOT KS_RECONNECT;
  IF (l and TU_SAVESSID)<>0 THEN
     l2:=l2 OR KS_SAVESSID ELSE
     l2:=l2 AND NOT KS_SAVESSID;
  IF (l and TU_BBS)<>0 THEN
     l2:=l2 OR KS_BBS ELSE
     l2:=l2 AND NOT KS_BBS;
  IF (l and TU_REMOTE)<>0 THEN
     l2:=l2 OR KS_REMOTE ELSE
     l2:=l2 AND NOT KS_REMOTE;
  IF (l and TU_INACTIVE)<>0 THEN
     l2:=l2 OR KS_INACTIVE ELSE
     l2:=l2 AND NOT KS_INACTIVE;
  IF (l and TU_SENDPW)<>0 THEN
     l2:=l2 OR KS_SENDPW ELSE
     l2:=l2 AND NOT KS_SENDPW;
  TU_2_KS:=l2;
END;

FUNCTION KS_2_TU(l:LONGINT;l2:LONGINT):LONGINT;
BEGIN
  IF (l and KS_AUTOSAVE)<>0 THEN
     l2:=l2 OR TU_AUTOSAVE ELSE
     l2:=l2 AND NOT TU_AUTOSAVE;
  IF (l and KS_CONNECT)<>0 THEN
     l2:=l2 OR TU_CONNECT ELSE
     l2:=l2 AND NOT TU_CONNECT;
  IF (l and KS_RECONNECT)<>0 THEN
     l2:=l2 OR TU_RECONNECT ELSE
     l2:=l2 AND NOT TU_RECONNECT;
  IF (l and KS_SAVESSID)<>0 THEN
     l2:=l2 OR TU_SAVESSID ELSE
     l2:=l2 AND NOT TU_SAVESSID;
  IF (l and KS_BBS)<>0 THEN
     l2:=l2 OR TU_BBS ELSE
     l2:=l2 AND NOT TU_BBS;
  IF (l and KS_INACTIVE)<>0 THEN
     l2:=l2 OR TU_INACTIVE ELSE
     l2:=l2 AND NOT TU_INACTIVE;
  IF (l and KS_REMOTE)<>0 THEN
     l2:=l2 OR TU_REMOTE ELSE
     l2:=l2 AND NOT TU_REMOTE;
  IF (l and KS_SENDPW)<>0 THEN
     l2:=l2 OR TU_SENDPW ELSE
     l2:=l2 AND NOT TU_SENDPW;
  KS_2_TU:=l2;
END;

END.
